package be.iminds.ilabt.jfed.restapi.client;

import be.iminds.ilabt.jfed.fedmon.webapi.client.FedmonWebApiClient;
import be.iminds.ilabt.jfed.fedmon.webapi.service.json.*;
import be.iminds.ilabt.jfed.restapi.json.Experiment;
import be.iminds.ilabt.jfed.restapi.json.SpeaksForCredential;
import org.apache.http.client.utils.URIBuilder;

import java.net.URI;
import java.util.*;

/**
 * FedmonWebApiClient: easy to use client for fedmon api
 */
public interface JFedRestApiClient {
    public static class JFedRestApiClientException extends Exception {
        public JFedRestApiClientException() {
        }

        public JFedRestApiClientException(String message) {
            super(message);
        }

        public JFedRestApiClientException(String message, Throwable cause) {
            super(message, cause);
        }

        public JFedRestApiClientException(Throwable cause) {
            super(cause);
        }

        public JFedRestApiClientException(String message, Throwable cause, boolean enableSuppression, boolean writableStackTrace) {
            super(message, cause, enableSuppression, writableStackTrace);
        }
    }

    Optional<Experiment> getById(Class<Experiment> objectClass, Long id) throws JFedRestApiClientException;
    Map<Long, Experiment> getAllIndexedById(Class<Experiment> objectClass) throws JFedRestApiClientException;
    List<Experiment> getAll(Class<Long> objectClass) throws JFedRestApiClientException;

    Experiment create(Experiment object) throws JFedRestApiClientException;
    Experiment update(Experiment object) throws JFedRestApiClientException;
    Experiment delete(Experiment object) throws JFedRestApiClientException;
    Experiment deleteById(Class<Experiment> objectClass, Long id) throws JFedRestApiClientException;

    Optional<SpeaksForCredential> getSpeaksForCredential(String tld, String username) throws JFedRestApiClientException;
    SpeaksForCredential upsertSpeaksForCredential(SpeaksForCredential object) throws JFedRestApiClientException;
    void deleteSpeaksForCredential(SpeaksForCredential object) throws JFedRestApiClientException;

    void deleteByUri(URI uri) throws JFedRestApiClientException;
}
